import { Contract, PopulatedTransaction, providers } from "ethers";
import { Deposit, Fill, FillStatus, RelayData, SlowFillRequest } from "../interfaces";
import { SpokePoolClient } from "../clients";
type BlockTag = providers.BlockTag;
export declare function populateV3Relay(spokePool: Contract, deposit: Deposit, relayer: string, repaymentChainId?: number): Promise<PopulatedTransaction>;
export declare function getBlockRangeForDepositId(targetDepositId: number, initLow: number, initHigh: number, maxSearches: number, spokePool: SpokePoolClient): Promise<{
    low: number;
    high: number;
}>;
export declare function getDepositIdAtBlock(contract: Contract, blockTag: number): Promise<number>;
export declare function getRelayDataHash(relayData: RelayData, destinationChainId: number): string;
export declare function getRelayHashFromEvent(e: Deposit | Fill | SlowFillRequest): string;
export declare function relayFillStatus(spokePool: Contract, relayData: RelayData, blockTag?: number | "latest", destinationChainId?: number): Promise<FillStatus>;
export declare function fillStatusArray(spokePool: Contract, relayData: RelayData[], blockTag?: BlockTag): Promise<(FillStatus | undefined)[]>;
export declare function findFillBlock(spokePool: Contract, relayData: RelayData, lowBlockNumber: number, highBlockNumber?: number): Promise<number | undefined>;
export {};
